diff -ruN ccp4srs-old/srsgen.cpp ccp4srs/srsgen.cpp
--- ccp4srs-old/srsgen.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/srsgen.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -65,9 +65,9 @@
 #endif
 
 
-#include "mmdb/mmdb_tables.h"
-#include "mmdb/mmdb_mmcif.h"
-#include "mmdb/mmdb_graph.h"
+#include "mmdb2/mmdb_tables.h"
+#include "mmdb2/mmdb_mmcif_.h"
+#include "mmdb2/mmdb_math_graph.h"
 
 
 #ifdef  _WIN32
@@ -926,7 +926,7 @@
 }
 */
 
-void printInstructions ( pstr argv0 )  {
+void printInstructions ( mmdb::pstr argv0 )  {
 
   printf (
     "\n"
@@ -959,33 +959,33 @@
 
 DefineClass(CSortSRSIndex)
 
-class CSortSRSIndex : public CQuickSort  {
+class CSortSRSIndex : public mmdb::QuickSort  {
   public :
-    CSortSRSIndex() : CQuickSort() {}
+    CSortSRSIndex() : mmdb::QuickSort() {}
     int  Compare ( int i, int j );
     void Swap    ( int i, int j );
-    void Sort    ( PPCCP4SRSIndex   index,
-                   PPCCP4SRSMonomer monomer,
-                   PPCGraph         graph,
+    void Sort    ( ccp4srs::PPIndex    index,
+                   ccp4srs::PPMonomer  monomer,
+                   mmdb::math::PPGraph graph,
                    int nEntries );
   protected:
-    PPCCP4SRSMonomer m_array;
-    PPCGraph         g_array;
+    ccp4srs::PPMonomer  m_array;
+    mmdb::math::PPGraph g_array;
 };
 
 int CSortSRSIndex::Compare ( int i, int j )  {
-  return strcmp ( ((PPCCP4SRSIndex)data)[i]->entryID,
-                  ((PPCCP4SRSIndex)data)[j]->entryID );
+  return strcmp ( ((ccp4srs::PPIndex)data)[i]->entryID,
+                  ((ccp4srs::PPIndex)data)[j]->entryID );
 }
 
 void CSortSRSIndex::Swap ( int i, int j )  {
-PCCP4SRSIndex   I;
-PCCP4SRSMonomer M;
-PCGraph         G;
-
-  I = ((PPCCP4SRSIndex)data)[i];
-  ((PPCCP4SRSIndex)data)[i] = ((PPCCP4SRSIndex)data)[j];
-  ((PPCCP4SRSIndex)data)[j] = I;
+ccp4srs::PIndex    I;
+ccp4srs::PMonomer  M;
+mmdb::math::PGraph G;
+
+  I = ((ccp4srs::PPIndex)data)[i];
+  ((ccp4srs::PPIndex)data)[i] = ((ccp4srs::PPIndex)data)[j];
+  ((ccp4srs::PPIndex)data)[j] = I;
 
   M = m_array[i];
   m_array[i] = m_array[j];
@@ -998,13 +998,13 @@
 }
 
 
-void CSortSRSIndex::Sort ( PPCCP4SRSIndex   index,
-                           PPCCP4SRSMonomer monomer,
-                           PPCGraph         graph,
+void CSortSRSIndex::Sort ( ccp4srs::PPIndex    index,
+                           ccp4srs::PPMonomer  monomer,
+                           mmdb::math::PPGraph graph,
                            int nEntries )  {
   m_array = monomer;
   g_array = graph;
-  CQuickSort::Sort ( &(index[0]),nEntries );
+  mmdb::QuickSort::Sort ( &(index[0]),nEntries );
 }
 
 
@@ -1016,29 +1016,29 @@
 
     void FreeMemory();
 
-    int  openLogs ( cpstr dir );
-    void prints   ( cpstr S, int key );
+    int  openLogs ( mmdb::cpstr dir );
+    void prints   ( mmdb::cpstr S, int key );
     void closeLogs();
 
-    int readEnergyLib      ( cpstr monLib  );
-    int scanRCSBLibrary    ( cpstr rcsbLib );
-    int scanMonomerLibrary ( cpstr monLib, bool match_only );
+    int readEnergyLib      ( mmdb::cpstr monLib  );
+    int scanRCSBLibrary    ( mmdb::cpstr rcsbLib );
+    int scanMonomerLibrary ( mmdb::cpstr monLib, bool match_only );
 
     void sortIndex         ();
-    int  writeSRS          ( cpstr srsDir );
+    int  writeSRS          ( mmdb::cpstr srsDir );
 
   protected:
-    CMMCIFData       energyLib;
-    CGraphMatch      graphMatch;
-    CFile            fout;
-    CFile            ferr;
-    PPCCP4SRSIndex   srsIndex;
-    PPCCP4SRSMonomer srsMonomer;
-    PPCGraph         srsGraph;
-    CMemIO           memIO;
-    int              srsVersion;
-    int              nEntries,nEntries0;
-    bool             matchOnly;
+    mmdb::mmcif::Data      energyLib;
+    mmdb::math::GraphMatch graphMatch;
+    mmdb::io::File         fout;
+    mmdb::io::File         ferr;
+    ccp4srs::PPIndex       srsIndex;
+    ccp4srs::PPMonomer     srsMonomer;
+    mmdb::math::PPGraph    srsGraph;
+    ccp4srs::MemIO         memIO;
+    int                    srsVersion;
+    int                    nEntries,nEntries0;
+    bool                   matchOnly;
 
     // error counters
     int              n_rcsb_read_err;
@@ -1050,14 +1050,14 @@
     int              n_oldml_not_found;
     int              n_oldml_no_matches;
 
-    int  scanMonLibDirectory ( cpstr dirPath  );
-    int  processMonLibFile   ( cpstr filePath );
-    int  processRCSBFile     ( cpstr filePath );
-    void FillETLibData       ( PCCP4SRSMonomer monomer );
-    int  matchAtomNames      ( PCCP4SRSMonomer mon,
-                               PCCP4SRSMonomer mon_old );
-    int  processMonomer      ( PCCP4SRSMonomer monomer );
-    int  getMonomerNo        ( cpstr monID );
+    int  scanMonLibDirectory ( mmdb::cpstr dirPath  );
+    int  processMonLibFile   ( mmdb::cpstr filePath );
+    int  processRCSBFile     ( mmdb::cpstr filePath );
+    void FillETLibData       ( ccp4srs::PMonomer monomer );
+    int  matchAtomNames      ( ccp4srs::PMonomer mon,
+                               ccp4srs::PMonomer mon_old );
+    int  processMonomer      ( ccp4srs::PMonomer monomer );
+    int  getMonomerNo        ( mmdb::cpstr monID );
 
   private:
     int index_alloc;
@@ -1068,7 +1068,7 @@
 
 CMakeSRS::CMakeSRS()  {
 
-  srsVersion  = CCP4SRS_file_version;
+  srsVersion  = ccp4srs::CCP4SRS_file_version;
   srsIndex    = NULL;
   srsMonomer  = NULL;
   srsGraph    = NULL;
@@ -1117,19 +1117,19 @@
 
 }
 
-int CMakeSRS::openLogs ( cpstr dir )  {
-pstr fname;
-int  rc;
+int CMakeSRS::openLogs ( mmdb::cpstr dir )  {
+mmdb::pstr fname;
+int        rc;
 
   fname = NULL;
   rc    = 0;
 
-  CreateCopCat ( fname,dir,"srsgen_out.txt" );
-  fout.assign ( fname,True );
+  mmdb::CreateCopCat ( fname,dir,"srsgen_out.txt" );
+  fout.assign ( fname,true );
   if (!fout.rewrite())  rc = -1;
 
-  CreateCopCat ( fname,dir,"srsgen_err.txt" );
-  ferr.assign ( fname,True );
+  mmdb::CreateCopCat ( fname,dir,"srsgen_err.txt" );
+  ferr.assign ( fname,true );
   if (!ferr.rewrite())  rc = -2;
 
   delete[] fname;
@@ -1172,17 +1172,17 @@
 
 }
 
-void CMakeSRS::prints ( cpstr S, int key )  {
+void CMakeSRS::prints ( mmdb::cpstr S, int key )  {
   printf ( "%s",S );
   if (key & 0x00000001)  fout.Write ( S );
   if (key & 0x00000002)  ferr.Write ( S );
 }
 
-int CMakeSRS::getMonomerNo ( cpstr monID )  {
-int     l1,l2,l,k;
-ResName id;
+int CMakeSRS::getMonomerNo ( mmdb::cpstr monID )  {
+mmdb::ResName id;
+int           l1,l2,l,k;
 
-  strcpy_css ( id,monID );
+  mmdb::strcpy_css ( id,monID );
 
   k = -1;
 
@@ -1191,7 +1191,7 @@
       if (!strcmp(srsIndex[l]->entryID,id))
         k = l;
     if (k>=0)  return k;
-    return CCP4SRS_EntryNotFound;
+    return ccp4srs::CCP4SRS_EntryNotFound;
   }
 
   l  = 0;
@@ -1215,23 +1215,18 @@
     if (!strcmp(srsIndex[l1]->entryID,id))  return l1;
   }
 
-  return CCP4SRS_EntryNotFound;
+  return ccp4srs::CCP4SRS_EntryNotFound;
 
 }
 
 
-void CMakeSRS::FillETLibData ( PCCP4SRSMonomer monomer )  {
-PCMMCIFLoop  Loop;
-PCCP4SRSAtom Atom;
-//PCSBBond     Bond,Bond2;
-//PCSBAngle    angle;
-realtype     vdwRadius,vdwhRadius,ionRadius;
-//realtype     blength,blength_esd;
-cpstr         at1,et1,bt; //,at2, bt, et1,et2;
-//pstr         at21,at22;
-int          valency,sp;
-int          i,j,l,a1, rc;//,a2,order,btype, rc,found,nb,nb_esd;
-//int          a21,a22;
+void CMakeSRS::FillETLibData ( ccp4srs::PMonomer monomer )  {
+mmdb::mmcif::PLoop  Loop;
+ccp4srs::PAtom      Atom;
+mmdb::realtype      vdwRadius,vdwhRadius,ionRadius;
+mmdb::cpstr         at1,et1,bt;
+int                 valency,sp;
+int                 i,j,l,a1, rc;
 
   // 1. Set atom properties depending on energy type
 
@@ -1260,26 +1255,26 @@
         valency    = Atom->valency    ();
         sp         = Atom->sp         ();
         if (vdwRadius<=0.01)  {
-          if (Loop->GetReal(vdwRadius,"vdw_radius",a1,False))
-            vdwRadius = getVdWaalsRadius  ( Atom->element() );
+          if (Loop->GetReal(vdwRadius,"vdw_radius",a1,false))
+            vdwRadius = mmdb::getVdWaalsRadius  ( Atom->element() );
           Atom->set_vdw_radius ( vdwRadius );
         }
         if (vdwhRadius<=0.01)  {
-          if (Loop->GetReal(vdwhRadius,"vdwh_radius",a1,False))
-            vdwhRadius = vdwRadius + getVdWaalsRadius  ( "H" );
+          if (Loop->GetReal(vdwhRadius,"vdwh_radius",a1,false))
+            vdwhRadius = vdwRadius + mmdb::getVdWaalsRadius  ( "H" );
           Atom->set_vdwh_radius ( vdwhRadius );
         }
         if (ionRadius<=0.01)  {
-          if (Loop->GetReal(ionRadius,"ion_radius",a1,False))
-            ionRadius = getCovalentRadius ( Atom->element() );
+          if (Loop->GetReal(ionRadius,"ion_radius",a1,false))
+            ionRadius = mmdb::getCovalentRadius ( Atom->element() );
           Atom->set_ion_radius ( ionRadius );
         }
         if (valency<=0)  {
-          Loop->GetInteger ( valency,"valency",a1,False );
+          Loop->GetInteger ( valency,"valency",a1,false );
           Atom->set_valency ( valency );
         }
         if (sp<=0)  {
-          Loop->GetInteger ( sp,"sp",a1,False );
+          Loop->GetInteger ( sp,"sp",a1,false );
           if (sp<0)  sp = 0;
           Atom->set_sp ( sp );
         }
@@ -1296,10 +1291,10 @@
     }
     if (a1<0)  {
       // take whatever is possible from MMDB tables
-      Atom->set_vdw_radius  ( getVdWaalsRadius(Atom->element()) );
+      Atom->set_vdw_radius  ( mmdb::getVdWaalsRadius(Atom->element()) );
       Atom->set_vdwh_radius ( Atom->vdw_radius() +
-                              getVdWaalsRadius("H") );
-      Atom->set_ion_radius ( getCovalentRadius(Atom->element()) );
+                              mmdb::getVdWaalsRadius("H") );
+      Atom->set_ion_radius  ( mmdb::getCovalentRadius(Atom->element()) );
       Atom->set_valency ( 0 );    // valency is unknown
       Atom->set_sp      ( 0 );    // sp is unknown
       Atom->set_hb_type ( 'N' );  // no hydrogen bonding
@@ -1450,31 +1445,19 @@
 
 }
 
-/*
-int MakeElementType ( int ElType, char chirality, Boolean Cflag )  {
-  if (Cflag)  {
-    if (chirality=='S')  return ElType | CHIRAL_LEFT;
-    if (chirality=='R')  return ElType | CHIRAL_RIGHT;
-  }
-  return ElType;
-}
-*/
 
-int CMakeSRS::processMonomer ( PCCP4SRSMonomer monomer )  {
-PCCP4SRSIndex    index;
-//PCCP4SRSAtom     atom;
-//PCVertex         vertex;
-//PCEdge           edge;
-PPCCP4SRSIndex   kndex;
-PPCCP4SRSMonomer marray;
-PPCGraph         garray;
-PCGraph          graph;
-char             S[500];
-int              rc,i;//,vtype,vx1,vx2;
+int CMakeSRS::processMonomer ( ccp4srs::PMonomer monomer )  {
+ccp4srs::PIndex     index;
+ccp4srs::PPIndex    kndex;
+ccp4srs::PPMonomer  marray;
+mmdb::math::PPGraph garray;
+mmdb::math::PGraph  graph;
+char                S[500];
+int                 rc,i;
 
   rc    = 0;
 
-  index = new CCP4SRSIndex();
+  index = new ccp4srs::Index();
 
   strcpy ( index->entryID,monomer->ID() );
   index->nAtoms = monomer->n_atoms();
@@ -1573,9 +1556,9 @@
 
   if (nEntries>=index_alloc)  {
     index_alloc = nEntries + 5000;
-    kndex  = new PCCP4SRSIndex  [index_alloc];
-    marray = new PCCP4SRSMonomer[index_alloc];
-    garray = new PCGraph        [index_alloc];
+    kndex  = new ccp4srs::PIndex   [index_alloc];
+    marray = new ccp4srs::PMonomer [index_alloc];
+    garray = new mmdb::math::PGraph[index_alloc];
     for (i=0;i<nEntries;i++)  {
       kndex [i] = srsIndex  [i];
       marray[i] = srsMonomer[i];
@@ -1603,17 +1586,18 @@
 
 }
 
-int CMakeSRS::matchAtomNames ( PCCP4SRSMonomer mon,
-                               PCCP4SRSMonomer mon_old )  {
-PCGraph  graph;
-PCGraph  graph_old;
-AtomName aname1,aname2;
-ivector  FV1,FV2;
-ivector  amap;
-ivector  hcnt;
-realtype p1,p2;
-char     S[500];
-int      htype,nv,i,n1,n2, atm_old,atm_new,atm_h;
+
+int CMakeSRS::matchAtomNames ( ccp4srs::PMonomer mon,
+                               ccp4srs::PMonomer mon_old )  {
+mmdb::math::PGraph  graph;
+mmdb::math::PGraph  graph_old;
+mmdb::AtomName      aname1,aname2;
+mmdb::ivector       FV1,FV2;
+mmdb::ivector       amap;
+mmdb::ivector       hcnt;
+mmdb::realtype      p1,p2;
+char                S[500];
+int                 htype,nv,i,n1,n2, atm_old,atm_new,atm_h;
 
   if (mon->n_bonds()<=0)  {
     sprintf ( S," +++++ compound '%s' does not have a structure\n",
@@ -1649,23 +1633,23 @@
     return -2;
   }
 
-  htype = getElementNo(pstr("H"));
+  htype = mmdb::getElementNo(mmdb::pstr("H"));
 
   graph->ExcludeType ( htype );
   graph->MakeVertexIDs();
-  graph->MakeSymmetryRelief ( False );
-  graph->Build ( False );
+  graph->MakeSymmetryRelief ( false );
+  graph->Build ( false );
 
   graph_old->ExcludeType ( htype );
   graph_old->MakeVertexIDs();
-  graph_old->MakeSymmetryRelief ( False );
-  graph_old->Build ( False );
+  graph_old->MakeSymmetryRelief ( false );
+  graph_old->Build ( false );
 
-  graphMatch.SetMaxNofMatches ( 2,True );
+  graphMatch.SetMaxNofMatches ( 2,true );
   graphMatch.MatchGraphs ( graph,graph_old,
-                           IMin(graph->GetNofVertices(),
-                                graph_old->GetNofVertices()),
-                           True,EXTTYPE_Ignore );
+                           mmdb::IMin(graph->GetNofVertices(),
+                                      graph_old->GetNofVertices()),
+                           true,mmdb::math::EXTTYPE_Ignore );
 
   if (graphMatch.GetNofMatches()<=0)  {
 
@@ -1692,9 +1676,9 @@
     FV2 = NULL;
     graphMatch.GetMatch ( 0,FV1,FV2,nv,p1,p2 );
 
-    n1 = IMax(mon_old->n_atoms(),mon->n_atoms());
-    GetVectorMemory ( amap,n1,0 );
-    GetVectorMemory ( hcnt,n1,0 );
+    n1 = mmdb::IMax(mon_old->n_atoms(),mon->n_atoms());
+    mmdb::GetVectorMemory ( amap,n1,0 );
+    mmdb::GetVectorMemory ( hcnt,n1,0 );
     for (i=0;i<n1;i++)  {
       amap[i] = -1;
       hcnt[i] = 0;
@@ -1746,8 +1730,8 @@
         }
       }
 
-    FreeVectorMemory ( hcnt,0 );
-    FreeVectorMemory ( amap,0 );
+    mmdb::FreeVectorMemory ( hcnt,0 );
+    mmdb::FreeVectorMemory ( amap,0 );
 
   }
 
@@ -1760,19 +1744,19 @@
 }
 
 
-int CMakeSRS::processMonLibFile ( cpstr filePath )  {
+int CMakeSRS::processMonLibFile ( mmdb::cpstr filePath )  {
 // processing an entry from Monomer Library
-CMMCIFFile      mmCIFFile;
-PCMMCIFData     mmCIFData;
-PCCP4SRSMonomer monomer;
-PCCP4SRSAtom    atom;
-char            ErrLog[1000];
-ResName         rname;
-pstr            p;
-char            S[500];
-int             rc, nData,i,j, nMon;
+mmdb::mmcif::File  mmCIFFile;
+mmdb::mmcif::PData mmCIFData;
+ccp4srs::PMonomer  monomer;
+ccp4srs::PAtom     atom;
+char               ErrLog[1000];
+mmdb::ResName      rname;
+mmdb::pstr         p;
+char               S[500];
+int                rc, nData,i,j, nMon;
 
-  rc = mmCIFFile.ReadMMCIFFile ( filePath,GZM_CHECK );
+  rc = mmCIFFile.ReadMMCIFFile ( filePath,mmdb::io::GZM_CHECK );
 
   if (rc)  {
     sprintf ( S," +++ file %s read with return code %i\n",
@@ -1789,7 +1773,7 @@
     mmCIFData = mmCIFFile.GetCIFData ( i );
     if (strcmp(mmCIFData->GetDataName(),"comp_list"))  {
 
-      monomer = new CCP4SRSMonomer();
+      monomer = new ccp4srs::Monomer();
       rc      = monomer->readFromCIF ( mmCIFData,ErrLog );
       if (rc)  {
         sprintf ( S," +++ error reading monomer %s:\n"
@@ -1804,12 +1788,12 @@
       if (monomer)  {
 
         strcpy ( rname,mmCIFData->GetDataName() );
-        p = strchr ( rname,'_' );
+        p = mmdb::FirstOccurence ( rname,'_' );
         if (!p)  p  = rname;
            else  p++;
 
         nMon = getMonomerNo ( p );
-        if (nMon==CCP4SRS_EntryNotFound)  {
+        if (nMon==ccp4srs::CCP4SRS_EntryNotFound)  {
 
           if (matchOnly)  {
             sprintf ( S," +++ [%4i] compound '%s' from old ML is not "
@@ -1877,16 +1861,16 @@
 }
 
 
-int CMakeSRS::scanMonLibDirectory ( cpstr dirPath )  {
+int CMakeSRS::scanMonLibDirectory ( mmdb::cpstr dirPath )  {
 DIR    *dir;
 #if USE_DIRENT_H
 dirent *dp;
 #else
 direct *dp;
 #endif
-pstr  p;
-pstr  filePath;
-int   rc;
+mmdb::pstr p;
+mmdb::pstr filePath;
+int        rc;
 
   filePath = NULL;
   rc       = 0;
@@ -1897,10 +1881,10 @@
 
   dp = readdir ( dir );
   while (dp)  {
-    p = strrchr ( dp->d_name,'.' );
+    p = mmdb::LastOccurence ( dp->d_name,'.' );
     if (p)  {
       if (!strcmp(p,".cif"))  {
-        CreateCopCat ( filePath,dirPath,dp->d_name );
+        mmdb::CreateCopCat ( filePath,dirPath,dp->d_name );
         rc = processMonLibFile ( filePath );
       }
     }
@@ -1913,17 +1897,17 @@
 
 }
 
-int CMakeSRS::processRCSBFile ( cpstr filePath )  {
-CFile           compFile;
-CMMCIFData      mmCIFData;
-PCCP4SRSMonomer monomer;
-char            S[1000];
-char            L[1000];
-char            ErrLog[1000];
-int             lcount,rc;
+int CMakeSRS::processRCSBFile ( mmdb::cpstr filePath )  {
+mmdb::io::File    compFile;
+mmdb::mmcif::Data mmCIFData;
+ccp4srs::PMonomer monomer;
+char              S[1000];
+char              L[1000];
+char              ErrLog[1000];
+int               lcount,rc;
 
-  compFile.assign ( filePath,True,False );
-  if (!compFile.reset(True))  {
+  compFile.assign ( filePath,true,false );
+  if (!compFile.reset(true))  {
     sprintf ( S," *** cannot open components file %s\n",filePath );
     prints  ( S,3 );
     n_rcsb_read_err++;
@@ -1934,28 +1918,28 @@
 
     lcount     = 0;
     rc         = 0;
+    S[0] = char(0);
 
     while (!compFile.FileEnd())  {
 
-      S[0] = char(0);
       rc = mmCIFData.ReadMMCIFData ( compFile,S,lcount );
 
-      if (rc!=CIFRC_Ok)  {
+      if (rc!=mmdb::mmcif::CIFRC_Ok)  {
 
         if (rc<0)  {
-          sprintf ( S," *** error reading file:\n"
-                      "     %s\n",GetCIFMessage(L,rc) );
+          sprintf ( S," *** error reading file (%i):\n"
+                      "     %s\n",rc,mmdb::mmcif::GetCIFMessage(L,rc) );
           prints  ( S,3 );
           n_rcsb_read_err++;
         } else  {
           sprintf ( S," ... warning on reading file:\n"
-                      "     %s\n",GetCIFMessage(L,rc) );
+                      "     %s\n",mmdb::mmcif::GetCIFMessage(L,rc) );
           prints  ( S,3 );
         }
 
       } else  {
 
-        monomer = new CCP4SRSMonomer();
+        monomer = new ccp4srs::Monomer();
         rc = monomer->readFromCIF ( &mmCIFData,ErrLog );
         if (rc)  {
           sprintf ( S," +++ error reading monomer %s:\n"
@@ -1976,17 +1960,17 @@
 
 }
 
-int CMakeSRS::readEnergyLib ( cpstr monLib )  {
-pstr S;
-char L[1000];
-int  rc;
+int CMakeSRS::readEnergyLib ( mmdb::cpstr monLib )  {
+mmdb::pstr S;
+char       L[1000];
+int        rc;
 
   S  = NULL;
   rc = 0;
 
   S = NULL;
-  CreateCopCat ( S,monLib,"ener_lib.cif" );
-  energyLib.SetFlag ( CIFFL_PrintWarnings );
+  mmdb::CreateCopCat ( S,monLib,"ener_lib.cif" );
+  energyLib.SetFlag  ( mmdb::mmcif::CIFFL_PrintWarnings );
   rc = energyLib.ReadMMCIFData ( S );
   if (rc)  {
     sprintf ( L," *** cannot read energy type library:\n"
@@ -1994,7 +1978,7 @@
     prints  ( L,3 );
     delete[] S;
     S = new char[2000];
-    sprintf ( L," %s\n",GetCIFMessage(S,rc) );
+    sprintf ( L," %s\n",mmdb::mmcif::GetCIFMessage(S,rc) );
     prints  ( L,3 );
     delete S;
     n_elib_err++;
@@ -2011,16 +1995,16 @@
 
 }
 
-int CMakeSRS::scanRCSBLibrary ( cpstr rcsbLib )  {
+int CMakeSRS::scanRCSBLibrary ( mmdb::cpstr rcsbLib )  {
 DIR    *dir;
 #if USE_DIRENT_H
 dirent *dp;
 #else
 direct *dp;
 #endif
-pstr    S;
-char    L[1000];
-int     rc;
+mmdb::pstr S;
+char       L[1000];
+int        rc;
 
   S  = NULL;
   rc = 0;
@@ -2036,7 +2020,7 @@
   dp = readdir ( dir );
   while (dp)  {
     if (dp->d_name[0]!='.')  {
-      CreateCopCat ( S,rcsbLib,dp->d_name );
+      mmdb::CreateCopCat ( S,rcsbLib,dp->d_name );
       rc = processRCSBFile ( S );
     }
     dp = readdir ( dir );
@@ -2051,16 +2035,17 @@
 }
 
 
-int CMakeSRS::scanMonomerLibrary ( cpstr monLib, bool match_only )  {
+int CMakeSRS::scanMonomerLibrary ( mmdb::cpstr monLib,
+                                   bool match_only )  {
 DIR    *dir;
 #if USE_DIRENT_H
 dirent *dp;
 #else
 direct *dp;
 #endif
-pstr    S;
-char    L[1000];
-int     rc;
+mmdb::pstr S;
+char       L[1000];
+int        rc;
 
   matchOnly = match_only;
 
@@ -2078,7 +2063,7 @@
   dp = readdir ( dir );
   while (dp)  {
     if ((dp->d_name[0]!='.') && (!dp->d_name[1]))  {
-      CreateCopCat ( S,monLib,dp->d_name,_dir_sep );
+      mmdb::CreateCopCat ( S,monLib,dp->d_name,_dir_sep );
       rc = scanMonLibDirectory ( S );
     }
     dp = readdir ( dir );
@@ -2095,35 +2080,35 @@
   sortSRSIndex.Sort ( srsIndex,srsMonomer,srsGraph,nEntries );
 }
 
-int  CMakeSRS::writeSRS ( cpstr srsDir )  {
-CFile graphFile;
-CFile structFile;
-CFile indexFile;
-pstr  S;
-pstr  buffer;
-char  L[1000];
-int   i,n,k, buffer_length;
+int  CMakeSRS::writeSRS ( mmdb::cpstr srsDir )  {
+mmdb::io::File graphFile;
+mmdb::io::File structFile;
+mmdb::io::File indexFile;
+mmdb::pstr     S;
+mmdb::pstr     buffer;
+char           L[1000];
+int            i,n,k, buffer_length;
 
   S = NULL;
 
-  CreateCopCat ( S,srsDir,srsGraphFile );
-  graphFile.assign ( S,False,True );
+  mmdb::CreateCopCat ( S,srsDir,ccp4srs::srsGraphFile );
+  graphFile.assign ( S,false,true );
   if (!graphFile.rewrite())  {
     sprintf ( L," *** can't open srs file '%s' file.\n",S );
     prints  ( L,3 );
     return -111113;
   }
 
-  CreateCopCat ( S,srsDir,srsStructFile );
-  structFile.assign ( S,False,True );
+  mmdb::CreateCopCat ( S,srsDir,ccp4srs::srsStructFile );
+  structFile.assign ( S,false,true );
   if (!structFile.rewrite())  {
     sprintf ( L," *** can't open srs file '%s' file.\n",S );
     prints  ( L,3 );
     return -111114;
   }
 
-  CreateCopCat ( S,srsDir,srsIndexFile );
-  indexFile.assign ( S,False,True );
+  mmdb::CreateCopCat ( S,srsDir,ccp4srs::srsIndexFile );
+  indexFile.assign ( S,false,true );
   if (!indexFile.rewrite())  {
     sprintf ( L," *** can't open srs file '%s' file.\n",S );
     prints  ( L,3 );
@@ -2131,7 +2116,7 @@
   }
 
   prints ( "\n ... writing SRS files: ",1 );
-  k = 50;
+  k = mmdb::IMin(50,nEntries);
   for (i=0;i<k;i++)
     prints ( ".",1 );
   printf ( "\r ... writing SRS files: " );
@@ -2189,19 +2174,19 @@
 int main ( int argc, char ** argv, char ** env )  {
 UNUSED_ARGUMENT(env);
 CMakeSRS makeSRS;
-pstr     rcsbLib;
-pstr     monLib;
-pstr     oldMonLib;
-pstr     srsDir;
-char     S[1000];
-int      argNo,rc;
+mmdb::pstr rcsbLib;
+mmdb::pstr monLib;
+mmdb::pstr oldMonLib;
+mmdb::pstr srsDir;
+char       S[1000];
+int        argNo,rc;
 
   if (argc<2)  {
     printInstructions ( argv[0] );
     return 1;
   }
 
-  InitMatType();
+  mmdb::InitMatType();
   makeSRS.openLogs ( NULL );
 
   rcsbLib   = NULL;
@@ -2212,36 +2197,36 @@
   rc    = 0;
   argNo = 1;
 
-  CreateCopy ( rcsbLib,argv[argNo++] );
+  mmdb::CreateCopy ( rcsbLib,argv[argNo++] );
   if (rcsbLib[strlen(rcsbLib)-1]!=_dir_sep_c)
-    CreateConcat ( rcsbLib,_dir_sep );
+    mmdb::CreateConcat ( rcsbLib,_dir_sep );
 
   if (argNo<argc)  {
-    CreateCopy ( monLib,argv[argNo++] );
+    mmdb::CreateCopy ( monLib,argv[argNo++] );
     if (monLib[strlen(monLib)-1]!=_dir_sep_c)
-      CreateConcat ( monLib,_dir_sep );
+      mmdb::CreateConcat ( monLib,_dir_sep );
   }
 
   if (argNo<argc)  {
     if (!strcmp(argv[argNo],"-d"))  {
       argNo++;
-      CreateCopy ( srsDir,argv[argNo] );
+      mmdb::CreateCopy ( srsDir,argv[argNo] );
     } else {
-      CreateCopy ( oldMonLib,argv[argNo++] );
+      mmdb::CreateCopy ( oldMonLib,argv[argNo++] );
       if (oldMonLib[strlen(oldMonLib)-1]!=_dir_sep_c)
-        CreateConcat ( oldMonLib,_dir_sep );
+        mmdb::CreateConcat ( oldMonLib,_dir_sep );
       if (argNo<argc)  {
         if (!strcmp(argv[argNo++],"-d"))
-          CreateCopy ( srsDir,argv[argNo] );
+          mmdb::CreateCopy ( srsDir,argv[argNo] );
       }
     }
   }
 
   if (srsDir)  {
     if (srsDir[strlen(srsDir)-1]!=_dir_sep_c)
-      CreateConcat ( srsDir,_dir_sep );
+      mmdb::CreateConcat ( srsDir,_dir_sep );
   } else
-    CreateCopy ( srsDir,"" );
+    mmdb::CreateCopy ( srsDir,"" );
 
   sprintf ( S," \n"
               " ... RCSB library            : %s\n",rcsbLib );
@@ -2252,6 +2237,8 @@
     sprintf ( S," ... old CCP4 monomer library: %s\n",oldMonLib );
     makeSRS.prints ( S,1 );
   }
+  rc = makeSRS.readEnergyLib ( monLib );
+  if (rc)  return rc;
 
   sprintf ( S," ... SRS directory           : %s\n"
               "\n ... machine properties:\n"
@@ -2259,7 +2246,7 @@
               "      sizeof(short)  = %lu\n"
               "      sizeof(int)    = %lu\n"
               "      sizeof(long)   = %lu\n\n",
-              srsDir,MaxShortReal,
+              srsDir,mmdb::MaxShortReal,
               sizeof(short),sizeof(int),sizeof(long)  );
   makeSRS.prints ( S,1 );
 
